#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "lib.h"

extern int john(int socket);

#define FWD_OPCODE 0x0000000c

void usage(char *name)
{
  fprintf(stderr, "Usage: %s fw-address peer-address\n", name);
}

int main(int ac, char *av[])
{
  int s;
  unsigned long long_data;
  unsigned long fw_addr, peer_addr;

  // debug_lib();

  if (ac != 3) {
    usage(av[0]);
    return 1;
  }

  if ((fw_addr = inet_addr(av[1])) == (unsigned long)-1) {
    fprintf(stderr, "Invalid firewall address specified\n");
    return 1;
  }

  if ((peer_addr = inet_addr(av[2])) == (unsigned long)-1) {
    fprintf(stderr, "Invalid peer address specified\n");
    return 1;
  }

  if ((s = part_one(fw_addr, peer_addr, FWD_OPCODE, "none")) < 0)
    return 2;

  // Random number

  if (read_long(s, &long_data) < 0) {
    close(s);
    return 3;
  }

  printf("<- Status = %ld\n", long_data);

  if (long_data == 0) {
    fprintf(stderr, "Authentication failed\n");
    close(s);
    return 3;
  }

  if (part_two(s) < 0)
    return 3;

  close(s);
  return 0;
}
